attribute highp vec4 a_position;
attribute mediump vec3 a_normal;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewMatrix;
uniform highp mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_materialAmbient;

varying highp vec4 v_worldPos;
varying mediump vec3 v_normal;
varying mediump vec2 v_texCoord;

varying highp vec3 v_camPOS;

void main() {

	v_worldPos = u_modelViewProjectionMatrix * a_position;

	gl_Position = u_modelViewProjectionMatrix * a_position;

	v_texCoord = a_texCoord;

	v_camPOS = vec3( u_modelViewProjectionMatrix[0].w, u_modelViewProjectionMatrix[1].w, u_modelViewProjectionMatrix[2].w );

	mediump mat3 normalTransform = mat3(u_modelViewMatrix[0].xyz, u_modelViewMatrix[1].xyz, u_modelViewMatrix[2].xyz );

	v_normal = normalize( normalTransform * a_normal );

}